import 'dart:convert';

import 'package:http/http.dart';
import 'package:test_sa/models/lookup.dart';

import '../../controllers/api_routes/api_manager.dart';
import '../../controllers/api_routes/urls.dart';
import 'loading_list_notifier.dart';

class PpmServiceProvider extends LoadingListNotifier<Lookup> {
  @override
  Future getDate() async {
    if (loading ?? false) return -2;
    loading = true;
    notifyListeners();
    Response response;
    try {
      response = await ApiManager.instance.get(URLs.getPpmService);
    } catch (error) {
      loading = false;
      stateCode = -1;
      notifyListeners();
      return -1;
    }
    stateCode = response.statusCode;
    if (response.statusCode >= 200 && response.statusCode < 300) {
      // client's request was successfully received
      List listJson = json.decode(response.body)["data"];
      items = listJson.map((department) => Lookup.fromJson(department)).toList();
    }
    loading = false;
    notifyListeners();
    return response.statusCode;
  }
}
